
/* =========================================================================
 *
 *             Nanite Systems Applied Research Execution System
 *  
 *            Copyright (c) 2022–2023 Nanite Systems Corporation
 *  
 * =========================================================================
 *
 *  KERNEL.H.LSL Header Component
 *
 *  This program is covered under the terms of the ARES Software Copyright
 *  License, Section 3 (ASCL-iii). It may be redistributed or used as the
 *  basis of commercial, closed-source products so long as steps are taken
 *  to ensure proper attribution as defined in the text of the license.
 *  
 *  To see the full text of the ASCL, type 'help license' on any standard
 *  ARES distribution, or visit http://nanite-systems.com/ASCL for the
 *  current version.
 *
 *  DISCLAIMER
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 'AS
 *  IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 *  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *  PARTICULAR PURPOSE ARE DISCLAIMED.
 *
 *  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 *  DAMAGES HOWEVER CAUSED ON ANY THEORY OF LIABILITY ARISING IN ANY WAY OUT
 *  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGE.
 * 
 * =========================================================================
 *
 */

/*
	KERNEL INFORMATION QUERIES
*/

// kernel queries (each SIGNAL_QUERY_<topic> yields a SIGNAL_<topic>_REPORT reply):
#define query_modules() kernel(SIGNAL_QUERY_MODULES, "")
#define query_hooks() kernel(SIGNAL_QUERY_HOOKS, "")
#define query_daemons() kernel(SIGNAL_QUERY_DAEMONS, "")

/*
	EVENT HOOKS
	
	This asks the kernel to notify your program when something important happens. The list of supported events can be found in the <ARES/a> header.
*/

// hooking and unhooking events (provide a list of EVENT_* constants):
#define hook_events(...) kernel(SIGNAL_HOOK_EVENT, PROGRAM_NAME + "," + concat(__VA_ARGS__, ","));
#define unhook_events(...) kernel(SIGNAL_UNHOOK_EVENT, PROGRAM_NAME + "," + concat(__VA_ARGS__, ","));

// create a timer (interval must be an integer)
// delete by setting interval to 0
// tag is an arbitrary string used to disambiguate multiple timers for the same program
#define set_timer(_tag, _interval) kernel(SIGNAL_TIMER, (string)(_interval) + " " + (_tag))
